<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\logic\orders;


use app\common\model\orders\RechargeOrder;
use app\common\logic\BaseLogic;
use think\facade\Db;


/**
 * RechargeOrder逻辑
 * Class RechargeOrderLogic
 * @package app\adminapi\logic\orders
 */
class RechargeOrderLogic extends BaseLogic
{


    /**
     * @notes 添加
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public static function add(array $params): bool
    {
        Db::startTrans();
        try {
            RechargeOrder::create([
                'sn' => $params['sn'],
                'work_id' => $params['work_id'],
                'user_id' => $params['user_id'],
                'payment_type' => $params['payment_type'],
                'pay_sn' => $params['pay_sn'],
                'pay_way' => $params['pay_way'],
                'pay_status' => $params['pay_status'],
                'pay_time' => strtotime($params['pay_time']),
                'order_total' => $params['order_total'],
                'order_amount' => $params['order_amount'],
                'order_terminal' => $params['order_terminal'],
                'transaction_id' => $params['transaction_id'],
                'refund_status' => $params['refund_status'],
                'refund_transaction_id' => $params['refund_transaction_id'],
                'address' => $params['address'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 编辑
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public static function edit(array $params): bool
    {
        Db::startTrans();
        try {
            RechargeOrder::where('id', $params['id'])->update([
                'sn' => $params['sn'],
                'work_id' => $params['work_id'],
                'user_id' => $params['user_id'],
                'payment_type' => $params['payment_type'],
                'pay_sn' => $params['pay_sn'],
                'pay_way' => $params['pay_way'],
                'pay_status' => $params['pay_status'],
                'pay_time' => strtotime($params['pay_time']),
                'order_total' => $params['order_total'],
                'order_amount' => $params['order_amount'],
                'order_terminal' => $params['order_terminal'],
                'transaction_id' => $params['transaction_id'],
                'refund_status' => $params['refund_status'],
                'refund_transaction_id' => $params['refund_transaction_id'],
                'address' => $params['address'],
            ]);

            Db::commit();
            return true;
        } catch (\Exception $e) {
            Db::rollback();
            self::setError($e->getMessage());
            return false;
        }
    }


    /**
     * @notes 删除
     * @param array $params
     * @return bool
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public static function delete(array $params): bool
    {
        return RechargeOrder::destroy($params['id']);
    }


    /**
     * @notes 获取详情
     * @param $params
     * @return array
     * @author likeadmin
     * @date 2024/07/10 14:53
     */
    public static function detail($params): array
    {
        return RechargeOrder::findOrEmpty($params['id'])->toArray();
    }
}